#include <stdio.h>

void displayMenuEntry(int num, const char* option) {
    printf("%d - %s\n", num, option);
}

void displayMenu() {
    displayMenuEntry(1, "Addition");
    displayMenuEntry(2, "Soustraction");
    displayMenuEntry(3, "Multiplication");
    displayMenuEntry(4, "Division");
    displayMenuEntry(5, "Puissance");
    displayMenuEntry(6, "Quitter");
}

int prompt(const char* msg) {
    puts(msg);
    int value;
    scanf("%d", &value);
    return value;
}

int promptUserChoice() {
    int choice;
    displayMenu();
    return choice = prompt("Veuillez saisir un choix d'operation ?");
}

int doAddition(int val1, int val2) {
    return val1 + val2;
}

int doSubstraction(int val1, int val2) {
    return val1 - val2; 
}

int doMultiplication(int val1, int val2) {
    return val1 * val2;
}

int doDivision(int val1, int val2) {
    if (val2 == 0) {
        printf("Division par zero !\n");
        //FIXME: I'm not very fond of this convention ...
        return 0;
    } else {
        return val1 / val2;
    }
}

int doPuissance(int base, int expo) {
    int power = 1;
    for (int iter = 0; iter < expo; iter++) {
	power *= base ; 
    }
    return power;
}

int doPuissanceSmart(int base, int expo) {
    int power;
    if (expo == 1) {
        power = base;        	    
    } else if (expo % 2 == 0) {
	power = doPuissanceSmart(base*base, expo/2);    
    } else {
        power = base*doPuissanceSmart(base*base,(expo-1)/2);
    }
    return power;
}

int doPuissanceSmartIter(int base, int expo) {
    int power = 1;
    while (expo > 1) {
        if (expo % 2 == 0) {
            expo /= 2;
        } else {
	    power *= base;
	    expo = (expo - 1) / 2;
        }
    	base *= base;
    }
    return power * base;
}

int doOperation(int selection, int val1, int val2) {
    int op_result;
    switch (selection) {
        case 1:
            op_result = doAddition(val1, val2);           
            break;
        case 2:
            op_result = doSubstraction(val1, val2);           
            break;
        case 3:
            op_result = doMultiplication(val1, val2);           
            break;
        case 4:
            op_result = doDivision(val1, val2);           
            break;
        case 5:
            op_result = doPuissanceSmartIter(val1, val2);
            break;
        case 6:
            break;
        default:
            puts("Faire un choix entre 1 et 6");
    }
    return op_result;
}

/* int promptValue(const char* invite) {
    int input;
    return input = prompt(invite);
} */

void promptValue(const char* invite, int* value) {
    puts(invite);    
    scanf("%d", value);
}

void promptBothValues(int* val1, int* val2) {
    promptValue("Veuillez saisir la premiere valeur", val1);
    promptValue("Veuillez saisir la deuxieme valeur", val2);
}

int main() {
    int choiceresult, value1, value2, result;
    for (;;) {
        choiceresult = promptUserChoice();
        if (choiceresult == 6) break;	    
	promptBothValues(&value1, &value2);
        result = doOperation(choiceresult, value1, value2);
	printf("Le resultat est %d\n", result);
	printf("\n");
    }
}
